Ruby: pm_index_or_write_node Struct Reference

Ruby 3.4.3p32 (2025-04-14 revision d0b7e5b6a04bde21ca483d20a1546b28b401c2d4)

Data Fields
pm_index_or_write_node Struct Reference

IndexOrWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | receiver
| IndexOrWriteNode#receiver.
pm_location_t | call_operator_loc
| IndexOrWriteNode#call_operator_loc.
pm_location_t | opening_loc
| IndexOrWriteNode#opening_loc.
struct pm_arguments_node * | arguments
| IndexOrWriteNode#arguments.
pm_location_t | closing_loc
| IndexOrWriteNode#closing_loc.
struct pm_block_argument_node * | block
| IndexOrWriteNode#block.
pm_location_t | operator_loc
| IndexOrWriteNode#operator_loc.
struct pm_node * | value
| IndexOrWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

IndexOrWriteNode.

Represents the use of the `||=` operator on a call to `[]`.

    foo.bar[baz] ||= value
    ^^^^^^^^^^^^^^^^^^^^^^

Type: PM_INDEX_OR_WRITE_NODE

Flags (pm_call_node_flags):

- PM_CALL_NODE_FLAGS_SAFE_NAVIGATION
- PM_CALL_NODE_FLAGS_VARIABLE_CALL
- PM_CALL_NODE_FLAGS_ATTRIBUTE_WRITE
- PM_CALL_NODE_FLAGS_IGNORE_VISIBILITY

Definition at line 4724 of file ast.h.

## Field Documentation

## ◆ arguments

struct pm_arguments_node* pm_index_or_write_node::arguments

IndexOrWriteNode#arguments.

Definition at line 4747 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ base

pm_node_t pm_index_or_write_node::base

The embedded base node.

Definition at line 4726 of file ast.h.

Referenced by pm_dump_json().

## ◆ block

struct pm_block_argument_node* pm_index_or_write_node::block

IndexOrWriteNode#block.

Definition at line 4757 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ call_operator_loc

pm_location_t pm_index_or_write_node::call_operator_loc

IndexOrWriteNode#call_operator_loc.

Definition at line 4737 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_index_or_write_node::closing_loc

IndexOrWriteNode#closing_loc.

Definition at line 4752 of file ast.h.

Referenced by pm_dump_json().

## ◆ opening_loc

pm_location_t pm_index_or_write_node::opening_loc

IndexOrWriteNode#opening_loc.

Definition at line 4742 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_index_or_write_node::operator_loc

IndexOrWriteNode#operator_loc.

Definition at line 4762 of file ast.h.

Referenced by pm_dump_json().

## ◆ receiver

struct pm_node* pm_index_or_write_node::receiver

IndexOrWriteNode#receiver.

Definition at line 4732 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_index_or_write_node::value

IndexOrWriteNode#value.

Definition at line 4767 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h